import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
var _excluded = ["html", "css", "js", "title", "head", "onLoad"];
import React, { useMemo, useRef, useState } from 'react';
import ReactDOM from 'react-dom';
import { jsx as _jsx } from "react/jsx-runtime";
export default /*#__PURE__*/React.forwardRef(function (props, ref) {
  var _props$html = props.html,
      html = _props$html === void 0 ? '' : _props$html,
      css = props.css,
      js = props.js,
      _props$title = props.title,
      title = _props$title === void 0 ? 'Demo Title' : _props$title,
      head = props.head,
      _onLoad = props.onLoad,
      other = _objectWithoutPropertiesLoose(props, _excluded);

  var _useState = useState(false),
      isLoaded = _useState[0],
      setIsLoaded = _useState[1];

  var frameRef = useRef(null);
  var srcDoc = useMemo(function () {
    setIsLoaded(false);
    var jsString = js ? "<script type=\"text/javascript\">" + js + "</script>" : '';
    var cssString = css ? "<style>" + css + "</style>" : '';
    return "<!DOCTYPE html><html><head>" + cssString + "</head><body>" + html + "</body>" + jsString + "</html>";
  }, [css, html, js]);

  function renderFrameContents() {
    if (!frameRef.current || !frameRef.current.contentDocument || !frameRef.current.contentWindow) return null;
    return [/*#__PURE__*/ReactDOM.createPortal(head, frameRef.current.contentDocument.head)];
  }

  return /*#__PURE__*/_jsx("iframe", _extends({
    title: title,
    width: "100%",
    height: "100%",
    style: {
      border: 0
    }
  }, other, {
    onLoad: function onLoad(evn) {
      setIsLoaded(true);
      _onLoad && _onLoad(evn);
    },
    ref: frameRef,
    srcDoc: srcDoc,
    children: isLoaded && renderFrameContents()
  }));
});
//# sourceMappingURL=index.js.map